/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.ItemInvoiceReason;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ItemInvoiceReasonRecord extends UpdatableRecordImpl<ItemInvoiceReasonRecord> implements Record4<Integer, String, String, String> {

    private static final long serialVersionUID = 1967791055;

    /**
     * Setter for <code>ITEM_INVOICE_REASON.ID_ITEM_INVOICE_REASON</code>.
     */
    public void setIdItemInvoiceReason(Integer value) {
        set(0, value);
    }

    /**
     * Getter for <code>ITEM_INVOICE_REASON.ID_ITEM_INVOICE_REASON</code>.
     */
    public Integer getIdItemInvoiceReason() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>ITEM_INVOICE_REASON.CODE</code>.
     */
    public void setCode(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>ITEM_INVOICE_REASON.CODE</code>.
     */
    public String getCode() {
        return (String) get(1);
    }

    /**
     * Setter for <code>ITEM_INVOICE_REASON.DESCRIPTION</code>.
     */
    public void setDescription(String value) {
        set(2, value);
    }

    /**
     * Getter for <code>ITEM_INVOICE_REASON.DESCRIPTION</code>.
     */
    public String getDescription() {
        return (String) get(2);
    }

    /**
     * Setter for <code>ITEM_INVOICE_REASON.CONTO_SAP</code>.
     */
    public void setContoSap(String value) {
        set(3, value);
    }

    /**
     * Getter for <code>ITEM_INVOICE_REASON.CONTO_SAP</code>.
     */
    public String getContoSap() {
        return (String) get(3);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record4 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row4<Integer, String, String, String> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row4<Integer, String, String, String> valuesRow() {
        return (Row4) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return ItemInvoiceReason.ITEM_INVOICE_REASON.ID_ITEM_INVOICE_REASON;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return ItemInvoiceReason.ITEM_INVOICE_REASON.CODE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field3() {
        return ItemInvoiceReason.ITEM_INVOICE_REASON.DESCRIPTION;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field4() {
        return ItemInvoiceReason.ITEM_INVOICE_REASON.CONTO_SAP;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getIdItemInvoiceReason();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getCode();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component3() {
        return getDescription();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component4() {
        return getContoSap();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getIdItemInvoiceReason();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getCode();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value3() {
        return getDescription();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value4() {
        return getContoSap();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ItemInvoiceReasonRecord value1(Integer value) {
        setIdItemInvoiceReason(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ItemInvoiceReasonRecord value2(String value) {
        setCode(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ItemInvoiceReasonRecord value3(String value) {
        setDescription(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ItemInvoiceReasonRecord value4(String value) {
        setContoSap(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ItemInvoiceReasonRecord values(Integer value1, String value2, String value3, String value4) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached ItemInvoiceReasonRecord
     */
    public ItemInvoiceReasonRecord() {
        super(ItemInvoiceReason.ITEM_INVOICE_REASON);
    }

    /**
     * Create a detached, initialised ItemInvoiceReasonRecord
     */
    public ItemInvoiceReasonRecord(Integer idItemInvoiceReason, String code, String description, String contoSap) {
        super(ItemInvoiceReason.ITEM_INVOICE_REASON);

        set(0, idItemInvoiceReason);
        set(1, code);
        set(2, description);
        set(3, contoSap);
    }
}
